module jp.ku6.bbs.main;

import jp.ku6.raptan.core;
import jp.ku6.raptan.filter;
import jp.ku6.bbs.constants;
import jp.ku6.bbs.action.ThreadListAction;

void main(string[] arguments)
{
	// フレームワークオブジェクトの生成
	auto raptan = new Raptan(8192, 8192, "/tmp");

	// 拡張子を判断して自動でContent-Typeを出力する設定
	auto contentTypeFilter = new ContentTypeFilter;
	contentTypeFilter.add("html", "text/html; charset=UTF-8");
	raptan.addFilter(contentTypeFilter);

	// リクエストメソッドフィルタリング設定
	raptan.addFilter(new RequestMethodFilter(Request.Method.GET | Request.Method.POST));

	// パスに対して処理を設定
	auto threadListAction = new ThreadListAction;
	raptan.setAction(APPLICATION_ROOT_URI ~ "/ThreadList.html", &threadListAction.execute);

	// リクエストの受付を開始
	raptan.start();

	// アプリケーションの終了を待機
	raptan.join();
}
